require "import"
import "android.app.*"
import "android.content.*"
import "android.os.Vibrator"
import "android.speech.RecognizerIntent"
import "android.speech.tts.TextToSpeech"
import "android.net.Uri"

local Locale = luajava.bindClass("java.util.Locale")
local tts
local vibrator

function initTTS()
  tts = TextToSpeech(activity, TextToSpeech.OnInitListener{
    onInit = function(status)
      if status == TextToSpeech.SUCCESS then
        tts.setLanguage(Locale("ro"))
      end
    end
  })
end

function vibrate()
  vibrator = activity.getSystemService(Context.VIBRATOR_SERVICE)
  if vibrator then
    vibrator.vibrate(300) -- Vibrație de 300ms înainte de dictare
  end
end

function speakText(text)
  if tts then tts.speak(text, TextToSpeech.QUEUE_FLUSH, nil, "ttsID") end
end

function startVoiceRecognition()
  vibrate() -- Vibrație înainte de dictare
  local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
  intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
  intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ro-RO")
  intent.putExtra(RecognizerIntent.EXTRA_PROMPT, "Spune ce vrei să cauți pe YouTube...")
  activity.startActivityForResult(intent, 1)
end

function openYouTubeSearch(query)
  local url = "https://www.youtube.com/results?search_query=" .. query:gsub(" ", "+")
  local intent = Intent(Intent.ACTION_VIEW, Uri.parse(url))
  intent.setPackage("com.google.android.youtube") -- Se asigură că se deschide în YouTube
  activity.startActivity(intent)
  speakText("> Caut pe YouTube: " .. query)
end

function onActivityResult(requestCode, resultCode, data)
  if requestCode == 1 and resultCode == -1 and data then
    local matches = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS)
    if matches and matches.size() > 0 then
      openYouTubeSearch(matches.get(0))
    end
  end
end

function onCreate()
  initTTS()
  startVoiceRecognition()
end